from settable09 import Settable
from switchable09 import Switchable


class MusicPlayer(Settable, Switchable):
    def __init__(self):
        self.on = False
        self.playing = False
        self.name = "music player"
        self.type = "volume"
        self.setting = 7
        self.maximum = 11
        self.increment = 1
        self.radio_button = None
        self.slider = None
        print(f"{self.name} has been initialised")

    def switch_off(self):
        if self.playing:
            self.pause()
        self.on = False
        self.status()

    def status(self):
        if self.radio_button is not None:
            self.radio_button.set(self.on)
        if self.on:
            if self.playing:
                print(self.name + " is playing")
            else:
                print(self.name + " is on (paused)")
            self.print_setting()
        else:
            print(self.name + " is off")

    def play(self):
        if not self.on:
            self.switch_on()
        self.playing = True
        self.status()

    def pause(self):
        self.playing = False
        self.status()
