import tkinter as tk

import product10 as p

product_name = "Pizza"
products = {"margherita": 6.0, "napoletana": 7.0, "marinara": 7.5}
extras = {"mushrooms": 0.5, "cheese": 1.0, "anchovies": 1.5, "sausage": 1.8}


def respond():
    product_type = chosen.get()
    product_price = products[product_type]
    description = product_type
    extras_description = ""
    for extra in extras:
        if extra_chosen[extra].get():
            if extras_description == "":
                extras_description += f" with extra {extra}"
            else:
                extras_description += f", {extra}"
            product_price += extras[extra]
    description += extras_description
    print(f"{product_name} chosen is {description}")
    txt_output.set(f"{product_name} price is £{product_price:.2f}")


def add_to_basket():
    product_type = chosen.get()
    product_price = products[product_type]
    chosen_product = p.Product(product_type, product_price)
    for extra in extras:
        if extra_chosen[extra].get():
            extra_price = extras[extra]
            chosen_product.add_extra(extra, extra_price)
    basket.append(chosen_product)
    set_basket_contents()


def empty_basket():
    basket.clear()
    set_basket_contents()


def set_basket_contents():
    txt2["state"] = "normal"
    txt2.delete("1.0", tk.END)
    contents = ""
    total_cost = 0
    for chosen_product in basket:
        contents += chosen_product.get_description() + "\n"
        total_cost += chosen_product.price
    txt2.insert(1.0, contents)
    txt2["state"] = "disabled"
    basket_output.set(f"Total cost is £{total_cost:.2f}")


window = tk.Tk()
window.geometry("500x600")
window.title(f"Python {product_name}s")

basket = []

row_counter = 0

lbl0 = tk.Label(window, text=f"{product_name}s", font=("Arial Bold", 20))
lbl0.grid(column=0, row=row_counter, sticky="W")
row_counter += 1

chosen = tk.StringVar(window)
chosen.set(list(products)[0])

for product in products:
    rad = tk.Radiobutton(window, text=f"{product} - £{products[product]:.2f}", value=product, variable=chosen,
                         command=respond)
    rad.grid(column=0, row=row_counter, sticky="W")
    row_counter += 1

lbl1 = tk.Label(window, text="Extras", font=("Arial Bold", 20))
lbl1.grid(column=0, row=row_counter, sticky="W")
row_counter += 1

extra_chosen = {}
for extra in extras:
    extra_chosen[extra] = tk.BooleanVar(window)
    chk = tk.Checkbutton(window, text=f"{extra} - £{extras[extra]:.2f}", var=extra_chosen[extra], command=respond)
    chk.grid(column=0, row=row_counter, sticky="W")
    row_counter += 1

txt_output = tk.StringVar(window)

txt = tk.Entry(window, width=25, textvariable=txt_output, state="readonly")
txt.grid(column=0, row=row_counter, sticky="W", padx=5, pady=5)
row_counter += 1

add_button = tk.Button(window, text="Add to basket", command=add_to_basket)
add_button.grid(column=0, row=row_counter, sticky="W", padx=5, pady=5)

empty_button = tk.Button(window, text="Empty basket", command=empty_basket)
empty_button.grid(column=1, row=row_counter, sticky="W", padx=5, pady=5)
row_counter += 1

lbl1 = tk.Label(window, text="Basket", font=("Arial Bold", 20))
lbl1.grid(column=0, row=row_counter, sticky="W")
row_counter += 1

txt2 = tk.Text(window, width=60, height=10, state="disabled")
txt2.grid(column=0, row=row_counter, columnspan=2, sticky="W", padx=5, pady=5)
row_counter += 1

basket_output = tk.StringVar(window)

txt3 = tk.Entry(window, width=25, textvariable=basket_output, state="readonly")
txt3.grid(column=0, row=row_counter, sticky="W", padx=5, pady=5)
row_counter += 1

respond()

window.mainloop()
